/* DesktopFileEnumerator.c generated by valac 0.39.7, the Vala compiler
 * generated from DesktopFileEnumerator.vala, do not modify */

/*
* Copyright (c) 2013-2017 elementary LLC. (http://launchpad.net/switchboard-plug-applications)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Julien Spautz <spautz.julien@gmail.com>
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <gio/gio.h>


#define STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR (startup_backend_desktop_file_enumerator_get_type ())
#define STARTUP_BACKEND_DESKTOP_FILE_ENUMERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR, StartupBackendDesktopFileEnumerator))
#define STARTUP_BACKEND_DESKTOP_FILE_ENUMERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR, StartupBackendDesktopFileEnumeratorClass))
#define STARTUP_BACKEND_IS_DESKTOP_FILE_ENUMERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR))
#define STARTUP_BACKEND_IS_DESKTOP_FILE_ENUMERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR))
#define STARTUP_BACKEND_DESKTOP_FILE_ENUMERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR, StartupBackendDesktopFileEnumeratorClass))

typedef struct _StartupBackendDesktopFileEnumerator StartupBackendDesktopFileEnumerator;
typedef struct _StartupBackendDesktopFileEnumeratorClass StartupBackendDesktopFileEnumeratorClass;
typedef struct _StartupBackendDesktopFileEnumeratorPrivate StartupBackendDesktopFileEnumeratorPrivate;
enum  {
	STARTUP_BACKEND_DESKTOP_FILE_ENUMERATOR_0_PROPERTY,
	STARTUP_BACKEND_DESKTOP_FILE_ENUMERATOR_NUM_PROPERTIES
};
static GParamSpec* startup_backend_desktop_file_enumerator_properties[STARTUP_BACKEND_DESKTOP_FILE_ENUMERATOR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _StartupBackendDesktopFileEnumerator {
	GObject parent_instance;
	StartupBackendDesktopFileEnumeratorPrivate * priv;
};

struct _StartupBackendDesktopFileEnumeratorClass {
	GObjectClass parent_class;
};

struct _StartupBackendDesktopFileEnumeratorPrivate {
	gchar* dir;
};


static gpointer startup_backend_desktop_file_enumerator_parent_class = NULL;

GType startup_backend_desktop_file_enumerator_get_type (void) G_GNUC_CONST;
#define STARTUP_BACKEND_DESKTOP_FILE_ENUMERATOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR, StartupBackendDesktopFileEnumeratorPrivate))
StartupBackendDesktopFileEnumerator* startup_backend_desktop_file_enumerator_new (const gchar* dir);
StartupBackendDesktopFileEnumerator* startup_backend_desktop_file_enumerator_construct (GType object_type,
                                                                                        const gchar* dir);
gchar** startup_backend_desktop_file_enumerator_get_desktop_files (StartupBackendDesktopFileEnumerator* self,
                                                                   int* result_length1);
static gchar** startup_backend_desktop_file_enumerator_try_getting_desktop_files (StartupBackendDesktopFileEnumerator* self,
                                                                           int* result_length1,
                                                                           GError** error);
static gboolean startup_backend_desktop_file_enumerator_directory_exists (StartupBackendDesktopFileEnumerator* self,
                                                                   GError** error);
static gchar** startup_backend_desktop_file_enumerator_enumerate_children (StartupBackendDesktopFileEnumerator* self,
                                                                    int* result_length1,
                                                                    GError** error);
gboolean startup_utils_is_desktop_file (const gchar* name);
static gchar* startup_backend_desktop_file_enumerator_create_path_from_name (StartupBackendDesktopFileEnumerator* self,
                                                                      const gchar* name);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void startup_backend_desktop_file_enumerator_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


StartupBackendDesktopFileEnumerator*
startup_backend_desktop_file_enumerator_construct (GType object_type,
                                                   const gchar* dir)
{
	StartupBackendDesktopFileEnumerator * self = NULL;
	gchar* _tmp0_;
#line 29 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	g_return_val_if_fail (dir != NULL, NULL);
#line 29 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	self = (StartupBackendDesktopFileEnumerator*) g_object_new (object_type, NULL);
#line 30 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp0_ = g_strdup (dir);
#line 30 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_g_free0 (self->priv->dir);
#line 30 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	self->priv->dir = _tmp0_;
#line 29 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	return self;
#line 122 "DesktopFileEnumerator.c"
}


StartupBackendDesktopFileEnumerator*
startup_backend_desktop_file_enumerator_new (const gchar* dir)
{
#line 29 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	return startup_backend_desktop_file_enumerator_construct (STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR, dir);
#line 131 "DesktopFileEnumerator.c"
}


gchar**
startup_backend_desktop_file_enumerator_get_desktop_files (StartupBackendDesktopFileEnumerator* self,
                                                           int* result_length1)
{
	gchar** result = NULL;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GError * _inner_error_ = NULL;
#line 33 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 146 "DesktopFileEnumerator.c"
	{
		gchar** _tmp0_ = NULL;
		gint _tmp1_;
		gchar** _tmp2_;
		gint _tmp0__length1;
		gint __tmp0__size_;
		gchar** _tmp3_;
		gint _tmp3__length1;
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 35 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp2_ = startup_backend_desktop_file_enumerator_try_getting_desktop_files (self, &_tmp1_, &_inner_error_);
#line 35 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp0_ = _tmp2_;
#line 35 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp0__length1 = _tmp1_;
#line 35 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		__tmp0__size_ = _tmp0__length1;
#line 35 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 167 "DesktopFileEnumerator.c"
			goto __catch9_g_error;
		}
#line 35 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp3_ = _tmp0_;
#line 35 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp3__length1 = _tmp0__length1;
#line 35 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp0_ = NULL;
#line 35 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp0__length1 = 0;
#line 35 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp4_ = _tmp3_;
#line 35 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp4__length1 = _tmp3__length1;
#line 35 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		if (result_length1) {
#line 35 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
			*result_length1 = _tmp4__length1;
#line 186 "DesktopFileEnumerator.c"
		}
#line 35 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		result = _tmp4_;
#line 35 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp0_ = (_vala_array_free (_tmp0_, _tmp0__length1, (GDestroyNotify) g_free), NULL);
#line 35 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		return result;
#line 194 "DesktopFileEnumerator.c"
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 34 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		e = _inner_error_;
#line 34 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_inner_error_ = NULL;
#line 37 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp5_ = e;
#line 37 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp6_ = _tmp5_->message;
#line 37 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		g_warning ("DesktopFileEnumerator.vala:37: %s", _tmp6_);
#line 34 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_g_error_free0 (e);
#line 214 "DesktopFileEnumerator.c"
	}
	__finally9:
#line 34 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 34 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 34 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		g_clear_error (&_inner_error_);
#line 34 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		return NULL;
#line 225 "DesktopFileEnumerator.c"
	}
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp7_ = g_new0 (gchar*, 0 + 1);
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp8_ = _tmp7_;
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp8__length1 = 0;
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	if (result_length1) {
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		*result_length1 = _tmp8__length1;
#line 237 "DesktopFileEnumerator.c"
	}
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	result = _tmp8_;
#line 40 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	return result;
#line 243 "DesktopFileEnumerator.c"
}


static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 51 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	if ((*length) == (*size)) {
#line 51 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 51 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 259 "DesktopFileEnumerator.c"
	}
#line 51 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	(*array)[(*length)++] = value;
#line 51 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	(*array)[*length] = NULL;
#line 265 "DesktopFileEnumerator.c"
}


static gchar**
startup_backend_desktop_file_enumerator_try_getting_desktop_files (StartupBackendDesktopFileEnumerator* self,
                                                                   int* result_length1,
                                                                   GError** error)
{
	gchar** result = NULL;
	gchar** _result_ = NULL;
	gchar** _tmp0_;
	gint _result__length1;
	gint __result__size_;
	gboolean _tmp1_ = FALSE;
	gchar** _tmp3_ = NULL;
	gint _tmp4_;
	gchar** _tmp5_;
	gint _tmp3__length1;
	gint __tmp3__size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	GError * _inner_error_ = NULL;
#line 43 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 44 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_result_ = _tmp0_;
#line 44 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_result__length1 = 0;
#line 44 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	__result__size_ = _result__length1;
#line 46 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp1_ = startup_backend_desktop_file_enumerator_directory_exists (self, &_inner_error_);
#line 46 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 46 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		g_propagate_error (error, _inner_error_);
#line 46 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_result_ = (_vala_array_free (_result_, _result__length1, (GDestroyNotify) g_free), NULL);
#line 46 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		return NULL;
#line 308 "DesktopFileEnumerator.c"
	}
#line 46 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	if (!_tmp1_) {
#line 312 "DesktopFileEnumerator.c"
		gchar** _tmp2_;
		gint _tmp2__length1;
#line 47 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp2_ = _result_;
#line 47 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp2__length1 = _result__length1;
#line 47 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		if (result_length1) {
#line 47 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
			*result_length1 = _tmp2__length1;
#line 323 "DesktopFileEnumerator.c"
		}
#line 47 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		result = _tmp2_;
#line 47 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		return result;
#line 329 "DesktopFileEnumerator.c"
	}
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp5_ = startup_backend_desktop_file_enumerator_enumerate_children (self, &_tmp4_, &_inner_error_);
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp3_ = _tmp5_;
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp3__length1 = _tmp4_;
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	__tmp3__size_ = _tmp3__length1;
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		g_propagate_error (error, _inner_error_);
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_result_ = (_vala_array_free (_result_, _result__length1, (GDestroyNotify) g_free), NULL);
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		return NULL;
#line 347 "DesktopFileEnumerator.c"
	}
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		name_collection = _tmp3_;
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		name_collection_length1 = _tmp3__length1;
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		for (name_it = 0; name_it < _tmp3__length1; name_it = name_it + 1) {
#line 360 "DesktopFileEnumerator.c"
			gchar* _tmp6_;
			gchar* name = NULL;
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
			_tmp6_ = g_strdup (name_collection[name_it]);
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
			name = _tmp6_;
#line 367 "DesktopFileEnumerator.c"
			{
				const gchar* _tmp7_;
#line 50 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
				_tmp7_ = name;
#line 50 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
				if (startup_utils_is_desktop_file (_tmp7_)) {
#line 374 "DesktopFileEnumerator.c"
					gchar** _tmp8_;
					gint _tmp8__length1;
					const gchar* _tmp9_;
					gchar* _tmp10_;
#line 51 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
					_tmp8_ = _result_;
#line 51 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
					_tmp8__length1 = _result__length1;
#line 51 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
					_tmp9_ = name;
#line 51 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
					_tmp10_ = startup_backend_desktop_file_enumerator_create_path_from_name (self, _tmp9_);
#line 51 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
					_vala_array_add1 (&_result_, &_result__length1, &__result__size_, _tmp10_);
#line 389 "DesktopFileEnumerator.c"
				}
#line 49 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
				_g_free0 (name);
#line 393 "DesktopFileEnumerator.c"
			}
		}
	}
#line 53 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp11_ = _result_;
#line 53 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp11__length1 = _result__length1;
#line 53 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	if (result_length1) {
#line 53 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		*result_length1 = _tmp11__length1;
#line 405 "DesktopFileEnumerator.c"
	}
#line 53 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	result = _tmp11_;
#line 53 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 53 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	return result;
#line 413 "DesktopFileEnumerator.c"
}


static gboolean
startup_backend_desktop_file_enumerator_directory_exists (StartupBackendDesktopFileEnumerator* self,
                                                          GError** error)
{
	gboolean result = FALSE;
	const gchar* _tmp0_;
#line 56 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 57 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp0_ = self->priv->dir;
#line 57 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	result = g_file_test (_tmp0_, G_FILE_TEST_EXISTS);
#line 57 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	return result;
#line 431 "DesktopFileEnumerator.c"
}


static void
_vala_array_add2 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 65 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	if ((*length) == (*size)) {
#line 65 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 65 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 447 "DesktopFileEnumerator.c"
	}
#line 65 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	(*array)[(*length)++] = value;
#line 65 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	(*array)[*length] = NULL;
#line 453 "DesktopFileEnumerator.c"
}


static gchar**
startup_backend_desktop_file_enumerator_enumerate_children (StartupBackendDesktopFileEnumerator* self,
                                                            int* result_length1,
                                                            GError** error)
{
	gchar** result = NULL;
	gchar** _result_ = NULL;
	gchar** _tmp0_;
	gint _result__length1;
	gint __result__size_;
	GFileInfo* file_info = NULL;
	GFileEnumerator* enumerator = NULL;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFileEnumerator* _tmp4_;
	GFileEnumerator* _tmp5_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	GError * _inner_error_ = NULL;
#line 60 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 61 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_result_ = _tmp0_;
#line 61 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_result__length1 = 0;
#line 61 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	__result__size_ = _result__length1;
#line 63 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp1_ = self->priv->dir;
#line 63 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 63 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp3_ = _tmp2_;
#line 63 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp4_ = g_file_enumerate_children (_tmp3_, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error_);
#line 63 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp5_ = _tmp4_;
#line 63 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_g_object_unref0 (_tmp3_);
#line 63 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	enumerator = _tmp5_;
#line 63 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 63 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		g_propagate_error (error, _inner_error_);
#line 63 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_g_object_unref0 (file_info);
#line 63 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_result_ = (_vala_array_free (_result_, _result__length1, (GDestroyNotify) g_free), NULL);
#line 63 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		return NULL;
#line 511 "DesktopFileEnumerator.c"
	}
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	while (TRUE) {
#line 515 "DesktopFileEnumerator.c"
		GFileInfo* _tmp6_ = NULL;
		GFileEnumerator* _tmp7_;
		GFileInfo* _tmp8_;
		GFileInfo* _tmp9_;
		GFileInfo* _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		GFileInfo* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp7_ = enumerator;
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp8_ = g_file_enumerator_next_file (_tmp7_, NULL, &_inner_error_);
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp6_ = _tmp8_;
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
			g_propagate_error (error, _inner_error_);
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
			_g_object_unref0 (enumerator);
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
			_g_object_unref0 (file_info);
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
			_result_ = (_vala_array_free (_result_, _result__length1, (GDestroyNotify) g_free), NULL);
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
			return NULL;
#line 544 "DesktopFileEnumerator.c"
		}
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp9_ = _tmp6_;
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp6_ = NULL;
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_g_object_unref0 (file_info);
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		file_info = _tmp9_;
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp10_ = file_info;
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		if (!(_tmp10_ != NULL)) {
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
			_g_object_unref0 (_tmp6_);
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
			break;
#line 562 "DesktopFileEnumerator.c"
		}
#line 65 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp11_ = _result_;
#line 65 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp11__length1 = _result__length1;
#line 65 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp12_ = file_info;
#line 65 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp13_ = g_file_info_get_name (_tmp12_);
#line 65 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 65 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_vala_array_add2 (&_result_, &_result__length1, &__result__size_, _tmp14_);
#line 64 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		_g_object_unref0 (_tmp6_);
#line 578 "DesktopFileEnumerator.c"
	}
#line 66 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp15_ = _result_;
#line 66 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp15__length1 = _result__length1;
#line 66 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	if (result_length1) {
#line 66 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
		*result_length1 = _tmp15__length1;
#line 588 "DesktopFileEnumerator.c"
	}
#line 66 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	result = _tmp15_;
#line 66 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_g_object_unref0 (enumerator);
#line 66 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_g_object_unref0 (file_info);
#line 66 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	return result;
#line 598 "DesktopFileEnumerator.c"
}


static gchar*
startup_backend_desktop_file_enumerator_create_path_from_name (StartupBackendDesktopFileEnumerator* self,
                                                               const gchar* name)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 69 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 70 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp0_ = self->priv->dir;
#line 70 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_tmp1_ = g_build_filename (_tmp0_, name, NULL);
#line 70 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	result = _tmp1_;
#line 70 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	return result;
#line 621 "DesktopFileEnumerator.c"
}


static void
startup_backend_desktop_file_enumerator_class_init (StartupBackendDesktopFileEnumeratorClass * klass)
{
#line 25 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	startup_backend_desktop_file_enumerator_parent_class = g_type_class_peek_parent (klass);
#line 25 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	g_type_class_add_private (klass, sizeof (StartupBackendDesktopFileEnumeratorPrivate));
#line 25 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	G_OBJECT_CLASS (klass)->finalize = startup_backend_desktop_file_enumerator_finalize;
#line 634 "DesktopFileEnumerator.c"
}


static void
startup_backend_desktop_file_enumerator_instance_init (StartupBackendDesktopFileEnumerator * self)
{
#line 25 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	self->priv = STARTUP_BACKEND_DESKTOP_FILE_ENUMERATOR_GET_PRIVATE (self);
#line 643 "DesktopFileEnumerator.c"
}


static void
startup_backend_desktop_file_enumerator_finalize (GObject * obj)
{
	StartupBackendDesktopFileEnumerator * self;
#line 25 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR, StartupBackendDesktopFileEnumerator);
#line 27 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	_g_free0 (self->priv->dir);
#line 25 "/builddir/build/BUILD/switchboard-plug-applications-0.1.2/src/Startup/Backend/DesktopFileEnumerator.vala"
	G_OBJECT_CLASS (startup_backend_desktop_file_enumerator_parent_class)->finalize (obj);
#line 657 "DesktopFileEnumerator.c"
}


/**
 * This class lists all .desktop files in a given directory.
 */
GType
startup_backend_desktop_file_enumerator_get_type (void)
{
	static volatile gsize startup_backend_desktop_file_enumerator_type_id__volatile = 0;
	if (g_once_init_enter (&startup_backend_desktop_file_enumerator_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StartupBackendDesktopFileEnumeratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) startup_backend_desktop_file_enumerator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StartupBackendDesktopFileEnumerator), 0, (GInstanceInitFunc) startup_backend_desktop_file_enumerator_instance_init, NULL };
		GType startup_backend_desktop_file_enumerator_type_id;
		startup_backend_desktop_file_enumerator_type_id = g_type_register_static (G_TYPE_OBJECT, "StartupBackendDesktopFileEnumerator", &g_define_type_info, 0);
		g_once_init_leave (&startup_backend_desktop_file_enumerator_type_id__volatile, startup_backend_desktop_file_enumerator_type_id);
	}
	return startup_backend_desktop_file_enumerator_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



